// #name = DoubleWeaponSlots

package DoubleWeaponSlots {

function DoubleWeaponSlots1(%val) { if (%val) DoubleWeaponSlots(1); }
function DoubleWeaponSlots2(%val) { if (%val) DoubleWeaponSlots(2); }
function DoubleWeaponSlots3(%val) { if (%val) DoubleWeaponSlots(3); }
function DoubleWeaponSlots4(%val) { if (%val) DoubleWeaponSlots(4); }
function DoubleWeaponSlots5(%val) { if (%val) DoubleWeaponSlots(5); }

function DoubleWeaponSlots(%slot)
{
    %first = $pref::DoubleWeaponSlots::Slot[%slot, 1];
    %second = $pref::DoubleWeaponSlots::Slot[%slot, 2];
    %slot = -1;
    for(%i = 0; %i < weaponshud.getNumSlots(); %i++)
    {
        if(weaponshud.getSlotId(%i) == weaponshud.getActiveItem())
        {
            %slot = %i;
            break;
        }
    }
    if (%slot == %first)
    {
        if($WeaponNames[weaponshud.getSlotId(%second)] $= "TargetingLaser")
            use("TargetingLaser");
        else
            commandToServer( 'selectWeaponSlot', %second );
    }
    else
    {
        if($WeaponNames[weaponshud.getSlotId(%first)] $= "TargetingLaser")
            use("TargetingLaser");
        else
            commandToServer( 'selectWeaponSlot', %first );
    }
}

function DoubleWeaponSlotsDefaults()
{
	$pref::DoubleWeaponSlots::Slot[1, 1] = 0;
	$pref::DoubleWeaponSlots::Slot[1, 2] = 1;
	$pref::DoubleWeaponSlots::Slot[2, 1] = 2;
	$pref::DoubleWeaponSlots::Slot[2, 2] = 3;
	$pref::DoubleWeaponSlots::Slot[3, 1] = 4;
	$pref::DoubleWeaponSlots::Slot[3, 2] = 5;
	$pref::DoubleWeaponSlots::Slot[4, 1] = 1;
	$pref::DoubleWeaponSlots::Slot[4, 2] = 4;
	$pref::DoubleWeaponSlots::Slot[5, 1] = 2;
	$pref::DoubleWeaponSlots::Slot[5, 2] = 5;
}

function DoubleWeaponSlotsOptions(%val)
{
	if (%val) DoubleWeaponSlotsDlgToggle();
}

function DoubleWeaponSlotsDlgToggle()
{
	if (!DoubleWeaponSlotsDlg.isAwake())
		Canvas.pushDialog(DoubleWeaponSlotsDlg);
	else
		Canvas.popDialog(DoubleWeaponSlotsDlg);
}

function DoubleWeaponSlotsDlg::OnWake(%this)
{
	for (%i = 1; %i < 6; %i++)
	{
		for (%j = 1; %j < 3; %j++)
		{
			for (%k = 0; %k < 6; %k++) DoubleWeaponSlotsDlg.Slot[%i, %j].add(%k, %k);
			DoubleWeaponSlotsDlg.Slot[%i, %j].setSelected($pref::DoubleWeaponSlots::Slot[%i, %j]);
		}
	}
	%this.wasCursorOn = Canvas.isCursorOn();
	if (!%this.wasCursorOn) CursorOn();
}

function DoubleWeaponSlotsDlg::OnSleep(%this)
{
	if (!%this.wasCursorOn) CursorOff();
	for (%i = 1; %i < 6; %i++)
	{
		for (%j = 1; %j < 3; %j++)
		{
			$pref::DoubleWeaponSlots::Slot[%i, %j] = DoubleWeaponSlotsDlg.Slot[%i, %j].getSelected();
			DoubleWeaponSlotsDlg.Slot[%i, %j].clear();
		}
	}
}

function DoubleWeaponSlotsSetDefaults()
{
	DoubleWeaponSlotsDefaults();
	for (%i = 1; %i < 6; %i++)
	{
		for (%j = 1; %j < 3; %j++)
		{
			DoubleWeaponSlotsDlg.Slot[%i, %j].clear();
			for (%k = 0; %k < 6; %k++) DoubleWeaponSlotsDlg.Slot[%i, %j].add(%k, %k);
			DoubleWeaponSlotsDlg.Slot[%i, %j].setSelected($pref::DoubleWeaponSlots::Slot[%i, %j]);
		}
	}
}

function DoubleWeaponSlotsDlgSetup()
{
	exec("gui/DoubleWeaponSlotsDlg.gui");
	if ($pref::DoubleWeaponSlots::Slot[1, 1] $= "") DoubleWeaponSlotsDefaults();
	for (%i = 1; %i <=5; %i++)
	{
		DoubleWeaponSlotsDlg.text[%i] = new GuiTextCtrl()
		{
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "15" SPC (25+(%i-1)*30);
			extent = "100 22";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "Slot "@%i@":";
			maxLength = "255";
		};
		DoubleWeaponSlotsDlgCtrl.add(DoubleWeaponSlotsDlg.text[%i]);
		for (%j = 1; %j <=2; %j++)
		{
			DoubleWeaponSlotsDlg.Slot[%i, %j] = new ShellPopupMenu()
			{
				profile = "ShellPopupProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = (51+(%j-1)*170) SPC (17+(%i-1)*30);
				extent = "180 36";
				minExtent = "49 36";
				visible = "1";
				helpTag = "0";
				text = "Select Weapon";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};
			DoubleWeaponSlotsDlgCtrl.add(DoubleWeaponSlotsDlg.Slot[%i, %j]);
		}
	}
}

function DispatchLaunchMode()
{
	DoubleWeaponSlotsDlgSetup();
	parent::DispatchLaunchMode();
}

function OptionsDlg::onWake(%this)
{
	if (!$DoubleWeaponSlotsOptions)
	{
		$RemapName[$RemapCount] = "DoubleWeaponSlots 1";
		$RemapCmd[$RemapCount]  = "DoubleWeaponSlots1";
		$RemapCount++;	
		$RemapName[$RemapCount] = "DoubleWeaponSlots 2";
		$RemapCmd[$RemapCount]  = "DoubleWeaponSlots2";
		$RemapCount++;	
		$RemapName[$RemapCount] = "DoubleWeaponSlots 3";
		$RemapCmd[$RemapCount]  = "DoubleWeaponSlots3";
		$RemapCount++;	
		$RemapName[$RemapCount] = "DoubleWeaponSlots 4";
		$RemapCmd[$RemapCount]  = "DoubleWeaponSlots4";
		$RemapCount++;	
		$RemapName[$RemapCount] = "DoubleWeaponSlots 5";
		$RemapCmd[$RemapCount]  = "DoubleWeaponSlots5";
		$RemapCount++;	
		$RemapName[$RemapCount] = "DoubleWeaponSlots Options";
		$RemapCmd[$RemapCount]  = "DoubleWeaponSlotsOptions";
		$RemapCount++;
		
		$DoubleWeaponSlotsOptions = true;
	}
	parent::onWake(%this);
}
};
activatePackage(DoubleWeaponSlots);
